//+------------------------------------------------------------------+
//|                                                          PPO.mq4 |
//|                                       Copyright  2007 Tom Balfe |
//|                                                                  |
//| Percentage Price Oscillator                                      |
//| This is a momentum indicator.                                    |
//| Signal line is SMA of PPO.                                       |
//|                                                                  |
//| Follows formula: (FastSMA-SlowSMA)/SlowSMA                       |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007 Tom Balfe"
#property link      "redcarsarasota@yahoo.com"
//----
#property indicator_separate_window
#property indicator_buffers 2
//----
#property indicator_color1 SkyBlue
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_width2 1
#property indicator_style2 2
//---- user changeable stuff
extern int FastSMA=15;
extern int SlowSMA=71;
extern int SignalSMA=15;
//---- two buffers
double     PPOBuffer[];
double     SignalBuffer[];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexDrawBegin(1,SignalSMA);
   IndicatorDigits(Digits+1);
   SetIndexBuffer(0,PPOBuffer);
   SetIndexBuffer(1,SignalBuffer);
//----
   IndicatorShortName("PPO ("+FastSMA+","+SlowSMA+","+SignalSMA+")");
   SetIndexLabel(0,"PPO");
   SetIndexLabel(1,"Signal");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- (FastSMA-SlowSMA)/SlowSMA
//---- PPO counted in the 1st buffer
   for(int i=0; i<limit; i++)
      if (iMA(NULL,0,SlowSMA,0,MODE_SMA,PRICE_CLOSE,i)!=0)
            PPOBuffer[i]=(iMA(NULL,0,FastSMA,0,MODE_SMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowSMA,0,MODE_SMA,PRICE_CLOSE,i))/iMA(NULL,0,SlowSMA,0,MODE_SMA,PRICE_CLOSE,i);
      else  PPOBuffer[i]=0;
   for(    i=0; i<limit; i++) SignalBuffer[i]=iMAOnArray(PPOBuffer,0,SignalSMA,0,MODE_SMA,i);
   return(0);
  }
//+------------------------------------------------------------------+